package info.buscalivro.buscalivro.fragments;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import org.json.JSONException;
import org.json.JSONObject;

import info.buscalivro.buscalivro.MainActivity;
import info.buscalivro.buscalivro.R;
import info.buscalivro.buscalivro.Utils;
import info.buscalivro.buscalivro.interfaces.DealResponse;
import info.buscalivro.buscalivro.objects.BookElement;

public class DetailsFragment extends Fragment {
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        return inflater.inflate(R.layout.details_fragment, container, false);
    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

        insertValues();
    }

    @Override
    public void onResume() {
        super.onResume();

        ((MainActivity) getActivity()).setToolbar(getActivity().getString(R.string.DetailsToolbarTitle), "", false);
    }

    private void insertValues() {
        Bundle extra = getArguments();

        View view = getView();
        if(view == null) {
            return;
        }

        int position = extra.getInt("position", 0);

        BookElement book;
        book = ((MainActivity) getActivity()).getElementList(position);

        /* set title */
        if(!book.getTitle().isEmpty()) {
            TextView title = (TextView) view.findViewById(R.id.book_title);
            title.setText(book.getTitle());
        }

        /* set author */
        if(!book.getAuthor().isEmpty()) {
            TextView book_author = (TextView) view.findViewById(R.id.book_author_publication);
            book_author.setText(" " + book.getAuthor());
        } else {
            View divider_author = view.findViewById(R.id.divider_author);
            divider_author.setVisibility(View.GONE);

            LinearLayout layout_author = (LinearLayout) view.findViewById(R.id.layout_author);
            layout_author.setVisibility(View.GONE);
        }

        /* set publication */
        if(!book.getPublication().isEmpty()) {
            TextView book_publication = (TextView) view.findViewById(R.id.book_publication);
            book_publication.setText(" " + book.getPublication());
        } else {
            View divider_publication = view.findViewById(R.id.divider_publication);
            divider_publication.setVisibility(View.GONE);

            LinearLayout layout_publication = (LinearLayout) view.findViewById(R.id.layout_publication);
            layout_publication.setVisibility(View.GONE);
        }

        /* set edition */
        if(!book.getEdition().isEmpty()) {
            TextView book_edition = (TextView) view.findViewById(R.id.book_edition);
            book_edition.setText(" " + book.getEdition());
        } else {
            View divider_edition = view.findViewById(R.id.divider_edition);
            divider_edition.setVisibility(View.GONE);

            LinearLayout layout_edition = (LinearLayout) view.findViewById(R.id.layout_edition);
            layout_edition.setVisibility(View.GONE);
        }

        /* set cdd */
        if(!book.getCdd().isEmpty()) {
            TextView cdd = (TextView) view.findViewById(R.id.cddBook);
            cdd.setText(" " + book.getCdd());
        } else {
            View divider_cdd = view.findViewById(R.id.divider_cdd);
            divider_cdd.setVisibility(View.GONE);

            LinearLayout layout_cdd = (LinearLayout) view.findViewById(R.id.layout_cdd);
            layout_cdd.setVisibility(View.GONE);
        }

        /* set pha */
        if(!book.getPha().isEmpty()) {
            TextView book_pha = (TextView) view.findViewById(R.id.book_pha);
            book_pha.setText(" " + book.getPha());
        } else {
            View divider_pha = view.findViewById(R.id.divider_pha);
            divider_pha.setVisibility(View.GONE);

            LinearLayout layout_pha = (LinearLayout) view.findViewById(R.id.layout_pha);
            layout_pha.setVisibility(View.GONE);
        }

        /* set library */
        if(!book.getLibrary().isEmpty()) {
            TextView book_library = (TextView) view.findViewById(R.id.book_library);
            book_library.setText(" " + book.getLibrary());
        } else {
            View divider_library = view.findViewById(R.id.divider_library);
            divider_library.setVisibility(View.GONE);

            LinearLayout layout_library = (LinearLayout) view.findViewById(R.id.layout_library);
            layout_library.setVisibility(View.GONE);
        }

        /* set kind */
        if(!book.getKind().isEmpty()) {
            TextView book_kind = (TextView) view.findViewById(R.id.book_kind);
            book_kind.setText(" " + book.getKind());
        } else {
            View divider_kind = view.findViewById(R.id.divider_kind);
            divider_kind.setVisibility(View.GONE);

            LinearLayout layout_kind = (LinearLayout) view.findViewById(R.id.layout_kind);
            layout_kind.setVisibility(View.GONE);
        }

        /* set description */
        if(!book.getDescription().isEmpty()) {
            TextView book_description = (TextView) view.findViewById(R.id.book_description);
            book_description.setText(" " + book.getDescription());
        } else {
            View divider_description = view.findViewById(R.id.divider_description);
            divider_description.setVisibility(View.GONE);

            LinearLayout layout_description = (LinearLayout) view.findViewById(R.id.layout_description);
            layout_description.setVisibility(View.GONE);
        }

        Utils.getAvaliables(getActivity(), book.getLibrary(), book.getField(), new DealResponse() {
            @Override
            public void withResponse(String response) {
                SetAvaliables(response);
            }

            @Override
            public void withoutResponse() {
                View view = getView();
                TextView num_total = (TextView) view.findViewById(R.id.num_total);
                num_total.setText("Desculpe, não foi possível verificar a disponibilidade");
                LinearLayout layout_description = (LinearLayout) view.findViewById(R.id.layout_avaliables_avaliables);
                layout_description.setVisibility(View.GONE);
            }
        });
    }

    private void SetAvaliables(String response) {
        View view = getView();
        if(view == null) {
            return;
        }
        JSONObject jo;
        try {
            jo = new JSONObject(response);

            if(jo.has("avaliables")) {
                TextView num_total = (TextView) view.findViewById(R.id.num_total);
                num_total.setText(" " + jo.getString("total"));
            } else {
                LinearLayout layout_description = (LinearLayout) view.findViewById(R.id.layout_avaliables_total);
                layout_description.setVisibility(View.GONE);
            }
            if(jo.has("total")) {
                TextView num_avaliables = (TextView) view.findViewById(R.id.num_avaliables);
                num_avaliables.setText(" " + jo.getString("avaliables"));
            } else {
                LinearLayout layout_description = (LinearLayout) view.findViewById(R.id.layout_avaliables_avaliables);
                layout_description.setVisibility(View.GONE);
            }
        } catch (JSONException e1) {
            e1.printStackTrace();
        }
    }
}
