package info.buscalivro.buscalivro.fragments;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.TextView;

import info.buscalivro.buscalivro.MainActivity;
import info.buscalivro.buscalivro.R;
import info.buscalivro.buscalivro.Utils;
import info.buscalivro.buscalivro.objects.SearchObj;

public class HomeFragment extends Fragment {

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        return inflater.inflate(R.layout.home_fragment, container, false);
    }

    @Override
    public void onResume() {
        super.onResume();

        ((MainActivity) getActivity()).setToolbar(getActivity().getString(R.string.HomeToolbarTitle), "", false);

        final EditText editText = (EditText) getActivity().findViewById(R.id.search_field);
        editText.setText("");
        editText.requestFocus();
        editText.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                Utils.closeKeyboard(getActivity());
                if (actionId == EditorInfo.IME_ACTION_SEARCH) {
                    ((MainActivity) getActivity()).makeSearch(getView());
                    return true;
                }
                return false;
            }
        });

        setTextView();
    }

    public void setTextView() {
        SearchObj search = ((MainActivity) getActivity()).getSearch();

        TextView libraryToSearch = (TextView) getActivity().findViewById(R.id.libraryToSearch);
        switch (search.getLibrary()) {
            case "":
                libraryToSearch.setText(getString(R.string.searchingAllLibrariesTextView));
                break;
            case "UEMS - Dourados":
                libraryToSearch.setText(getString(R.string.searchingUEMSTextView));
                break;
            case "UFGD - Central":
                libraryToSearch.setText(getString(R.string.searchingUFGDTextView));
                break;
            default:
                break;
        }
    }
}
