package info.buscalivro.buscalivro.fragments;

import android.app.ProgressDialog;
import android.os.Bundle;
import android.support.design.widget.Snackbar;
import android.support.v4.app.Fragment;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.EditorInfo;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import info.buscalivro.buscalivro.MainActivity;
import info.buscalivro.buscalivro.R;
import info.buscalivro.buscalivro.Utils;
import info.buscalivro.buscalivro.interfaces.DealResponse;

public class ReportErrorFragment extends Fragment implements View.OnClickListener {
    private EditText report_text;
    private ProgressDialog dialog;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.reporterror_fragment, container, false);

        Button sendErrorButton = (Button) view.findViewById(R.id.sendError);
        report_text = (EditText) view.findViewById(R.id.report_text);
        sendErrorButton.setOnClickListener(this);
        return view;
    }

    @Override
    public void onResume() {
        super.onResume();

        ((MainActivity) getActivity()).setToolbar(getActivity().getString(R.string.ReportErrorToolbarTitle), "", false);

        report_text.requestFocus();
        report_text.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                Utils.closeKeyboard(getActivity());
                if (actionId == EditorInfo.IME_ACTION_SEND) {
                    sendErrorMsg();
                    return true;
                }
                return false;
            }
        });
    }

    @Override
    public void onClick(View v) {
        sendErrorMsg();
    }

    private void sendErrorMsg() {
        if(!report_text.getText().toString().isEmpty()) {
            Utils.closeKeyboard(getActivity());

            if (Utils.isConnected(getActivity())) {
                dialog = ProgressDialog.show(getActivity(), null, getActivity().getString(R.string.SendingErrorDialog), true);
                Utils.sendError(getActivity(), report_text.getText().toString(), new DealResponse() {
                    @Override
                    public void withResponse(String response) {
                        dialog.dismiss();
                        Utils.showDialog(getActivity(), getActivity().getString(R.string.ThanksDialogTitle), getActivity().getString(R.string.ThanksDialogSubtitle), false);
                    }

                    @Override
                    public void withoutResponse() {
                        dialog.dismiss();
                        Utils.showDialog(getActivity(), getActivity().getString(R.string.TitleErrorConnectionDialog), getActivity().getString(R.string.MsgErrorConnectionDialog), false);
                    }
                });
            } else {
                Utils.showDialog(getActivity(), getActivity().getString(R.string.TitleErrorConnectionDialog), getActivity().getString(R.string.MsgErrorConnectionDialog), false);
            }
        } else {
            Snackbar.make(getActivity().findViewById(android.R.id.content), getActivity().getString(R.string.FieldTextInputReportError), Snackbar.LENGTH_LONG).show();
        }
    }
}
