package info.buscalivro.buscalivro.objects;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import java.util.List;

import info.buscalivro.buscalivro.R;
import info.buscalivro.buscalivro.interfaces.RecycleViewOnClickListenerHack;

public class BookAdapter extends RecyclerView.Adapter<BookAdapter.MyViewHolder> {
    private List<BookElement> mList;
    private LayoutInflater mLayoutInflater;
    private RecycleViewOnClickListenerHack mRecycleViewOnClickListenerHack;

    public BookAdapter(Context context, List<BookElement> l) {
        mList = l;
        mLayoutInflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    @Override
    public MyViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View v = mLayoutInflater.inflate(R.layout.book_item, parent, false);
        return new MyViewHolder(v);
    }

    @Override
    public void onBindViewHolder(MyViewHolder holder, int position) {
        holder.book_title.setText(mList.get(position).getTitle());
        holder.book_type_library.setText("[" + mList.get(position).getKind() + "]. " + mList.get(position).getLibrary());
        holder.book_author_publication.setText(mList.get(position).getAuthor() + ". " + mList.get(position).getPublication());
    }

    @Override
    public int getItemCount() { return mList.size(); }

    public void addListItem(BookElement b, int position) {
        mList.add(b);
        notifyItemInserted(position);
    }

    public void setRecycleViewOnClickListenerHack(RecycleViewOnClickListenerHack r) {
        mRecycleViewOnClickListenerHack = r;
    }

    public class MyViewHolder extends RecyclerView.ViewHolder implements View.OnClickListener {
        private TextView book_title;
        private TextView book_type_library;
        private TextView book_author_publication;

        public MyViewHolder(View itemView) {
            super(itemView);

            book_title = (TextView) itemView.findViewById(R.id.book_title);
            book_type_library = (TextView) itemView.findViewById(R.id.book_kind_library);
            book_author_publication = (TextView) itemView.findViewById(R.id.book_author_publication);

            itemView.setOnClickListener(this);
        }

        @Override
        public void onClick(View v) {
            if(mRecycleViewOnClickListenerHack != null) {
                mRecycleViewOnClickListenerHack.onClickListener(v, getPosition());
            }
        }
    }
}
