# -*- coding: utf-8 -*-
import os
from datetime import timedelta
from djcelery import setup_loader

BASE_DIR = os.path.dirname(os.path.dirname(__file__))

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = '(9!1(g13g&=0$m3j&qi$o@uke9=l=f+^=6&*$uzo9w^qad(sp1'

# Application definition
INSTALLED_APPS = (
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'djcelery',
    'kombu.transport.django',
    'location_field',
    'web_scraping',
    'search_server',
    'search_engine',
)

MIDDLEWARE_CLASSES = (
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.auth.middleware.SessionAuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
)

DATABASES = {
    'default': {
        'ENGINE': 'django.contrib.gis.db.backends.postgis',
        'NAME': 'buscalivro_bd',
        'USER': 'buscalivro_pg',
        'PASSWORD': 'buscalivro_pass',
        'HOST': 'localhost',
        'PORT': '',
    }
}

ROOT_URLCONF = 'buscalivro_web.urls'

WSGI_APPLICATION = 'buscalivro_web.wsgi.application'

LANGUAGE_CODE = 'en-us'
TIME_ZONE = 'UTC'
USE_I18N = True
USE_L10N = True
USE_TZ = True

# Find templates in the same folder as settings.py.
TEMPLATE_DIRS = (
    os.path.join(BASE_DIR, 'templates'),
)

STATIC_ROOT = os.path.normpath(os.path.join(BASE_DIR, 'static'))

STATIC_URL = '/static/'

STATICFILES_FINDERS = (
    'django.contrib.staticfiles.finders.FileSystemFinder',
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',
    'compressor.finders.CompressorFinder',
)

########## CELERY CONFIGURATION
CELERY_TASK_RESULT_EXPIRES = timedelta(minutes=30)
CELERY_CHORD_PROPAGATES = True
# BROKER_URL = 'amqp://guest:guest@localhost:5672//'
CELERY_ACCEPT_CONTENT = ['json']
CELERY_TASK_SERIALIZER = 'json'
CELERY_RESULT_SERIALIZER = 'json'
setup_loader()
########## END CELERY CONFIGURATION

########## SOLR CONFIGURATION
SOLR_BASEPATH = 'http://localhost:8983/solr/'
SOLR_CORE = 'buscalivro/'
########## END SOLR CONFIGURATION

########## WEB_SCRAPING SETTINGS
BOOK = {
    #All
    'id': "",
    'title': "",
    'description': "",
    'library': "",
    'kind': "",
    'author': "",
    'publication': "",
    'cdd': "",
    'pha': "",
    'year': "",

    #Books
    'edition': "",

    #Periodicals
    'periodicity': "",
    'country': "",
    'language': "",
    'editor': "",
    'cnn': "",
    'collections': "",

    #Thesis
    'knowledge_area': "",
}

KINDS = [u'Livro', u'Periódico', u'Monografia/TCC', u'Tese/Dissertação', u'Outro']

LIST_BOOKS = []

# UFGD settings
J_IDT = 'j_idt56'
SEARCH_LISTA = 'search:lista:%s:' + J_IDT
HEADERS = {
    'Cookie': '',
    'Referer': '',
    'Faces-Request': '',
}
PAYLOAD = {
    'search': 'search',
    'search:termo2': '',
    'search:j_idt41': 'conteudo',
    'javax.faces.ViewState': '',
    'javax.faces.partial.ajax': 'true',
    'javax.faces.source': '',
    'javax.faces.partial.execute': '@all',
    'javax.faces.partial.render': 'formMaterial',
    SEARCH_LISTA % str(-1): '', # 'hack'
}
PAYLOAD_PAGE = {
    'search': 'search',
    'search:termo2': '',
    'search:j_idt41': 'conteudo',
    'javax.faces.ViewState': '',
    'javax.faces.partial.ajax': 'true',
    'javax.faces.source': 'search:lista',
    'javax.faces.partial.execute': 'search:lista',
    'javax.faces.partial.render': 'search:lista',
    'search:lista:search': 'lista',
    'search:lista_ajaxPaging': 'true',
    'search:lista_first': '0',
    'search:lista_rows': '',
    'search:lista_page': '1',
}

COOKIE = ''
########## END WEB_SCRAPING SETTINGS

########## SEARCH SETTINGS
SEARCH_FILTERS = {
    'field': "", # campo que será buscado
    'query': "", # texto
    'library': "", # bibliotecas escolhidas
    'kind': [], # tipos escolhidos
    'fl': [], # lista de campos que retornarão
    'order_by': "" # ToDo
}
########## END SEARCH SETTINGS
