/* DEFINES */
RADIO_ON = 'mdi-toggle-radio-button-on'
RADIO_OFF = 'mdi-toggle-radio-button-off';
library = 'all';
kind  = 'all';
limit = 20;
offset = 0;
hits = 0;
show_msg = false;

/* INDEX */
$("#search_mobile_input").keyup(function() {
    $("#search_input").val($(this).val());
}).keyup();

$("#search_input").keyup(function() {
    $("#search_mobile_input").val($(this).val());
}).keyup();

/* SIDENAV*/
$('.button-collapse').sideNav({
    menuWidth: 320,
    closeOnClick: true
});


$( ".field" ).click(function() {
    $(".field > i").attr('class', RADIO_OFF);
    $(this).children().attr('class', RADIO_ON);
    field = $(this).children().attr('id')
    $("#field").attr('value', field);
    offset = 0;
    get_books_grid();

});


$( ".library" ).click(function() {
    $(".library > i").attr('class', RADIO_OFF);
    $(this).children().attr('class', RADIO_ON);
    library = $(this).children().attr('id')
    offset = 0;
    get_books_grid();
});


$( ".kind" ).click(function() {
    $(".kind > i").attr('class', RADIO_OFF);
    $(this).children().attr('class', RADIO_ON);
    kind = $(this).children().attr('id')
    offset = 0;
    get_books_grid();
});

function csrfSafeMethod(method) {
    // these HTTP methods do not require CSRF protection
    return (/^(GET|HEAD|OPTIONS|TRACE)$/.test(method));
}
$.ajaxSetup({
    beforeSend: function(xhr, settings) {
        if (!csrfSafeMethod(settings.type) && !this.crossDomain) {
            xhr.setRequestHeader("X-CSRFToken", csrftoken);
        }
    }
});

/* BOOKS */
function get_books_grid(){
    if(offset == 0){
        $('#grid').empty();
        $('#preloader').show();
        $('#slide-out').sideNav('hide');
        show_msg = true;
    }
    if(field == 'all')
        field = "";
    if(library == 'all')
        library = "";
    if(kind == 'all')
        kind = "";
    $.ajax({
        url: URL+'get_books_grid/',
        data: {
            'limit': limit,
            'offset': offset,
            'query': q.replace(/&quot;/g,'\"'),
            'field': field,
            'library': library,
            'kind': kind
        },
        error: function() {
            $('#preloader').hide();
            $('#grid').html("<p id='number_of_results'>Estamos enfrentado alguns problemas no servidor.<br>Por favor tente mais tarde!</p>")
        },
        dataType: 'json',
        success: function(data) {
            if(offset == 0){
                $('#preloader').hide();
                if (data['hits'] == '0')
                    text_result = "Nenhum Resultado Encontrado"
                else if(data['hits'] == '1')
                    text_result = data['hits']+" Resultado Encontrado";
                else
                    text_result = data['hits']+" Resultados Encontrados";
                    $('#grid').html("<p id='number_of_results'>"+text_result+"</p>")
                hits = data['hits']
            }
            for (var i=0; i<data['books'].length; i++) {
                if (data.hasOwnProperty("highlights") && !jQuery.isEmptyObject(data['highlights'])) {
                    hl_title = data['highlights'][data['books'][i].id].title;
                } else {
                    hl_title = null;
                }
                var title = hl_title ? hl_title[0] : data['books'][i].title;
                insert_book(data['books'][i], title);
            };
        },
        type: 'POST'
    });
}


function insert_book(book, highlighted_title){
    html = "<div id='"+book.id+"'>";
    html += "<b class='title'>"+highlighted_title+"</b><br>"
    html += "<b>["+book.kind+"]</b> "+book.library+"<br>"
    if(book.kind == "Periódico"){
        if(book.editor){
            html += book.editor+". "
        }
        if(book.country){
            html += book.country
        }
    }
    else{
        if(book.author){
            html += book.author+". "
        }
        if(book.publication){
            html += book.publication
        }
    }
    html += "</div>"
    $('#grid').append(html);
}


function load_avaliables(book){
    var field = '';
    if('id_uems' in book) {
        field = book.id_uems;
    } else if(book.library == "Biblioteca Central da UFGD") {
        field = "\"" + book.cdd + " " + book.pha + "\"";
    }
    $.ajax({
        url: URL+'get_avaliables/',
        data: {
            'library': book.library,
            'field': field
        },
        error: function() {
            str_ = "<b>Disponibilidade</b><br>";
            $('#search_avaliable').hide();
            str_ += "Desculpe, não foi possível verificar a disponibilidade de exemplares"
            $("#modal_avaliable").html(str_);
        },
        dataType: 'json',
        success: function(data) {
            $('#search_avaliable').hide();
            str_ = "<b>Disponibilidade</b><br>";
            if(data.total && data.avaliables){
                str_ += "<b>Total de exemplares: </b>" + data.total + "<br>";
                str_ += "<b>Exemplares disponíveis: </b>" + data.avaliables;
            }else{
                str_ += "Desculpe, não foi possível verificar a disponibilidade de exemplares";
            }
            $("#modal_avaliable").html(str_);
        },
        type: 'POST'
    });
}


function fills_modal_info(book){
    $("#modal_avaliable").empty();
    $("#modal_title").html(book.title);
    if(book.author)
        html = "<b>Autor: </b>"+book.author+"</b><br>";
    if(book.editor)
        html += "<b>Editor: </b>"+book.editor+"</b><br>";
    if(book.publication)
        html += "<b>Publicação: </b>"+book.publication+"</b><br>";
    if(book.section)
        html += "<b>Seção CDD: </b>"+book.section+"</b><br>";
    if(book.library)
        html += "<b>Biblioteca: </b>"+book.library+"</b><br>";
    if(book.periodicity)
        html += "<b>Periodicidade: </b>"+book.periodicity+"</b><br>";
    if(book.language)
        html += "<b>Idioma: </b>"+book.language+"</b><br>";
    if(book.collections)
        html += "<b>Coleções: </b>"+book.collections+"</b><br>";
    if(book.knowledge_area)
        html += "<b>Área do Conhecimento: </b>"+book.knowledge_area+"</b><br>";
    $("#modal_l").html(html);
    if(book.kind)
        html = "<b>Tipo: </b>"+book.kind+"</b><br>";
    if(book.country)
        html += "<b>Local: </b>"+book.country+"</b><br>";
    if(book.edition)
        html += "<b>Edição: </b>"+book.edition+"</b><br>";
    if(book.cdd)
        html += "<b>CDD: </b>"+book.cdd+"</b><br>";
    if(book.pha)
        html += "<b>PHA: </b>"+book.pha+"</b><br>";
    if(book.cnn)
        html += "<b>CNN: </b>"+book.cnn+"</b><br>";
    $("#modal_r").html(html);
    $('#modal_info').openModal();
    load_avaliables(book);
}


$("#grid").on("click", "div", function(){
    $.ajax({
        url: URL+'get_book_info/',
        data: {
            'id': $(this).attr('id')
        },
        error: function() {
            //ToDo MSG ERROR
            console.log("MSG ERROR");
        },
        dataType: 'json',
        success: function(data) {
            $('#search_avaliable').show();
            fills_modal_info(data);
        },
        type: 'POST'
    });
});

$(window).scroll(function() {
   if($(window).scrollTop() + $(window).height() > $(document).height() - 100) {
        if(offset < hits){
            offset += 20
            get_books_grid()
        }
        else if(show_msg){
            Materialize.toast('Todos resultados já exibidos', 4000)
            show_msg = false;
        }
    }
});

/* ONLOAD*/

$(window).load(function() {
    $('.modal-trigger').leanModal();
    if (page == "search") {
        $(".field > i").attr('class', RADIO_OFF);
        $(".library > i").attr('class', RADIO_OFF);
        $(".kind > i").attr('class', RADIO_OFF);
        $(".field > #"+field).attr('class', RADIO_ON);
        $(".library > #all").attr('class', RADIO_ON);
        $(".kind > #all").attr('class', RADIO_ON);
        $('.modal-trigger').leanModal();
        get_books_grid()
    };
});
