import json
import time

from django.conf import settings
from django.http import HttpResponse, Http404
from django.shortcuts import render
from django.template.context_processors import csrf

from utils import query_solr, search_Q
from models import ReportedError


def mobile_search_server(request):
    if request.method == 'POST':
        search = settings.SEARCH_FILTERS

        search['field'] = request.POST.get('field', '')
        search['query'] = request.POST.get('query', '')
        search['library'] = request.POST.get('library', '') # list of librarys to search
        search['kind'] = request.POST.get('kind', '').split(', ') # list of kinds to search
        search['fl'] = request.POST.get('fl', '').split(', ') # list of fls to return
        search['start'] = request.POST.get('start', '')
        search['rows'] = request.POST.get('rows', '')
        if len(search['kind']) >= 5:
            search['kind'] = None
        query, qf = search_Q(search)
        response = query_solr(q=query, qf=qf, fl=search['fl'], start=search['start'], rows=search['rows'])

        response_list = response.docs
        for i in response_list:
            if 'id_uems' in i:
                i['field'] = i['id_uems']
            else:
                if 'cdd' in i and 'pha' in i:
                    i['field'] = '\"' + i['cdd'] + ' ' + i['pha'] + '\"'
                else:
                    i['field'] = ''

        if response:
            response_list.append({'hits': str(response.hits)})

        return HttpResponse(json.dumps(response_list))
    else:
        raise Http404


def mobile_report_error(request):
    if request.method == 'POST':
        reportError = ''

        reportError = request.POST.get('reportError', '')

        reported = ReportedError()
        reported.error_message = reportError
        reported.save()

        return HttpResponse('')
    else:
        raise Http404


def get_cookie(request):
    return HttpResponse(csrf(request)['csrf_token'])
