# -*- coding: utf-8 -*-
from django.db import models

class UFGDCombination(models.Model):
    """

    This model identifies all possible combinations from UFGD searchs.

    Attributes:
        * Combination - Combination item
        * Results Number - Number of results to combination
        * Repeated Results - Number of repeated results to combination

    """
    combination = models.CharField(max_length=15, unique=True)
    results_number = models.IntegerField()
    geted_results = models.IntegerField()
    repeated_results = models.IntegerField()

class ScrapingTime(models.Model):
    """

    Save time of requests

    """
    initial_time = models.FloatField()
    end_time = models.FloatField()
    request_time = models.FloatField()
    is_valid = models.BooleanField(default=False)
    library = models.CharField(max_length=20)
