from __future__ import absolute_import
from celery import shared_task

from django.conf import settings

from .utils import uems_scraping_books, uems_scraping_periodics, ufgd_scraping, ufgd_get_cookie, ufgd_scraping_books
from .models import UFGDCombination


@shared_task
def scraping_uems(timeout=1.0):
    offset = 0
    limit = 45000

    settings.LIST_BOOKS = []

    for code in range(offset, limit):
        uems_scraping_books.apply_async(args=[timeout, code])

    offset = 0
    limit = 4000
    for code in range(offset, limit):
        uems_scraping_periodics.apply_async(args=[timeout, code])


@shared_task
def scraping_ufgd(timeout=2.0):
    settings.COOKIE = ''
    ufgd_scraping(timeout)


@shared_task
def scraping_ufgd_books(timeout=2.0):
    combs = UFGDCombination.objects.all().order_by('-results_number')
    cookie = ufgd_get_cookie(timeout, retry=True)
    settings.LIST_BOOKS = []
    for comb in combs:
        ufgd_scraping_books.apply_async(args=[comb.combination, cookie, timeout])
